if type(lib) == "table" and lib[0] == "LME" then
	if not lib.is_exist("killtrack") then
		lib.register("plugins/kill tracker/registration.ini")
		if lib.get_gstate().newstate == "NO" then
			return
		end
	end
	
	if not lib.is_ready("killtrack") then
		return
	end
end




local score_log = {}
local score_table = {}
--[[ score table:
[player name] = score index
[index] = kill score
]]--


local history = ""
local toggle_state = "OFF"
local dlg_flag = false
local dlg

local function do_update() end

local function add_score(player)
	local table_index = score_table[player]
	if score_table[table_index] == nil then
		score_table[table_index] = 0
	end
	score_table[table_index] = score_table[table_index] + 1
	do_update()
end

local function remove_score(player)
	local table_index = score_table[player]
	if score_table[table_index] == nil then
		score_table[table_index] = 1
	end
	score_table[table_index] = score_table[table_index] - 1
	do_update()
end

local function reset_score()
	for k, v in ipairs(score_table) do
		score_table[k] = 0
	end
	for k, v in pairs(score_log) do
		score_log[k] = {}
	end
	do_update()
end

local function create_diag()
	
	local player_view_details = iup.multiline {
		value = "",
		readonly = "YES",
		expand = "YES",
	}
	
	local player_selected
	local player_list = iup.stationsublist {
		expand = "VERTICAL",
		size = HUDSize(0.4, 0.5),
		action = function(self, string, index, click)
			player_selected = string
			local display = ""
			for k, v in ipairs(score_log[player_selected]) do
				display = display .. "\n" .. v
			end
			player_view_details.value = "Total score: " .. tostring(score_table[score_table[player_selected]]) .. "\n" .. display
		end,
	}
	
	local counter =1 
	
	local view_history = iup.multiline {
		value = history,
		readonly = "YES",
		expand = "HORIZONTAL",
		size = HUDSize(0.8, 0.3),
	}
	
	dlg_flag = true
	function do_update()
		if dlg_flag then
			view_history.value = history
			counter = 1
			for k, v in pairs(score_table) do
				if type(k) == "string" then
					player_list[counter] = k
					counter = counter + 1
				end
			end
		else
			do_update = function() end
		end
	end
	
	local diag = iup.dialog {
		topmost = "YES",
		fullscreen = "YES",
		bgcolor = "0 0 0 100 *",
		iup.vbox {
			iup.fill {
				size = "%5",
			},
			iup.hbox {
				iup.fill {
					size = "%10",
				},
				iup.stationmainframe {
					iup.vbox {
						iup.hbox {
							iup.label {
								title = "Kill Tracker",
							},
							iup.fill { },
							iup.button {
								title = "Close [X]",
								action = function(self)
									iup.GetDialog(self):hide()
								end,
							},
						},
						iup.vbox {
							view_history,
							iup.hbox {
								iup.fill { },
								iup.label {
									title = "Activate tracker: ",
								},
								iup.stationtoggle {
									value = toggle_state,
									title = "",
									action = function(self)
										toggle_state = self.value
									end,
								},
							},
						},
						iup.hbox {
							iup.vbox {
								player_list,
								iup.hbox {
									iup.button {
										title = "Score+",
										action = function()
											add_score(player_selected)
										end,
									},
									iup.button {
										title = "Score-",
										action = function()
											remove_score(player_selected)
										end,
									},
									iup.button {
										title = "Reset All",
										action = function()
											reset_score()
										end,
									},
								},
							},
							player_view_details,
						},
					},
				},
				iup.fill {
					size = "%10",
				},
			},
			iup.fill {
				size = "%10",
			},
		},
	}
	do_update()
	diag:map()
	diag:show()
	
	return diag
end

local function open_diag()
	if dlg_flag then
		dlg:show()
	else
		dlg = create_diag() 
	end
end

RegisterUserCommand("killtrack", open_diag)

RegisterEvent(function(event, deadguy, killer)
	if toggle_state == "ON" then
		print("killtrack: " .. GetPlayerName(killer) .. " >> " .. GetPlayerName(deadguy))
		if not score_table[GetPlayerName(killer)] then
			table.insert(score_table, 0)
			score_table[GetPlayerName(killer)] = #score_table
		end
		add_score(GetPlayerName(killer))
		score_log[GetPlayerName(killer)] = score_log[GetPlayerName(killer)] or {}
		table.insert(score_log[GetPlayerName(killer)], tostring(os.date()) .. ": Killed " .. GetPlayerName(deadguy))
		history = history .. "\n " .. GetPlayerName(killer) .. " >> " .. GetPlayerName(deadguy)
	end
end, "PLAYER_DIED")

if type(lib) == "table" and lib[0] == "LME" then
	lib.set_class("killtrack", "2", {open = open_diag})
end